import { TSFusionProcedure, TSFusionTemplate } from "./tsfusion";
import { Bytes, TSDictionary } from "./types";
export declare enum TSFusionContextType {
    Local = "local",
    Global = "global",
    Root = "root",
    System = "system",
    Procedure = "procedure",
    User = "user"
}
export declare enum TSFusionNodeType {
    Root = "root",
    Data = "data",
    Variable = "variable",
    Test = "test-variable",
    NegativeTest = "nagative-test-variable",
    Enumeration = "enumeration-variable"
}
export interface TSFusionEnumeration {
    fusionEnumeration(): any[];
}
export declare class TSFusionTreeNode {
    type: TSFusionNodeType;
    value?: string | Bytes;
    nodes?: TSFusionTreeNode[];
    parent?: TSFusionTreeNode;
    contextType: TSFusionContextType;
    private _localContext;
    private _pathCache;
    static root(): TSFusionTreeNode;
    private constructor();
    get label(): string;
    get isContainerVariable(): boolean;
    pushData(data: Bytes): void;
    pushVariable(name: string, type: TSFusionNodeType, contextType?: TSFusionContextType): TSFusionTreeNode;
    fusion(template: TSFusionTemplate, data: any, globalContext: TSDictionary, procedures?: TSDictionary<TSFusionProcedure>, errors?: string[]): boolean;
    private _cleanLocalContexts;
    private _fusion;
}
declare global {
    export interface Set<T> extends TSFusionEnumeration {
    }
    export interface Map<K, V> extends TSFusionEnumeration {
    }
}
