import { TSCharset } from './tscharset';
import { Nullable, StringDictionary, StringEncoding, TSDataLike } from './types';
export declare const $noop: () => void;
export declare function $inbrowser(): boolean;
export declare function $mark(): number;
export declare function $ellapsed(previousMark: number): string;
export declare function $timeout(promise: Promise<any>, time: number, exception: any): Promise<any>;
export interface $configOptions {
    encoding?: Nullable<StringEncoding | TSCharset>;
    debug?: Nullable<boolean>;
    underscoreMax?: Nullable<number>;
    variableMax?: Nullable<number>;
}
export declare function $config(path?: Nullable<string>, opts?: Nullable<$configOptions>): StringDictionary | null;
export interface $envOptions extends $configOptions {
    merge?: Nullable<StringDictionary>;
    reference?: Nullable<StringDictionary>;
}
export declare function $env(source: Nullable<string | TSDataLike>, opts?: Nullable<$envOptions>): StringDictionary | null;
export declare function $inspect(v: any, level?: number): string;
export declare function $insp(v: any, level?: number): string;
export declare function $term(s: string, escapeChar?: string): string;
export declare function $termclean(s: string, escapeChar?: string): string;
export declare function $logterm(format: string, ...args: any[]): void;
export declare function $writeterm(format: string, ...args: any[]): void;
export declare function $logheader(s: string, width?: number, style?: string, starStyle?: string): void;
export interface TSCall {
    getFunction(): (...args: any[]) => any | undefined;
    getFunctionName(): string | null;
    getMethodName(): string | undefined;
    getFileName(): string | null;
    getLineNumber(): number | null;
    getColumnNumber(): number | null;
    getEvalOrigin(): string | undefined;
    getTypeName(): string | null;
    getThis(): unknown | undefined;
}
export declare function $stack(): TSCall[];
export declare function _logwriteterm(log: boolean, format: string, args: any[]): void;
